#include <windows.h>
#include "KSockCPP.h"
#include <iostream.h>
#include <process.h>
#include <stdlib.h>
#include "vcdLotteWorld_telg.h"

BOOL WINAPI DllEntryPoint(HINSTANCE hDll, DWORD dwReason, LPVOID Reserved)
{
	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		{
			break;
		}
	case DLL_PROCESS_DETACH:
		{
			break;
		}
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
//Close Socket
/////////////////////////////////////////////////////////////////////////////
void CloseSocket()
{
	shutdown(sock, 2);
	closesocket(sock);
	WSACleanup();
}

/////////////////////////////////////////////////////////////////////////////
//Connet to Server
/////////////////////////////////////////////////////////////////////////////
int ConnectServer(char *lpszAddr, UINT nPort)
{
	SOCKADDR_IN SockAddr;
	WORD wVerRequest;
	WSADATA wsaData;
	
	nErrCode = 0;

	wVerRequest = MAKEWORD(2, 0);
	if (WSAStartup(wVerRequest, &wsaData) != 0)
	{
		//AfxMessageBox("Winsock2  ʴ ýԴϴ", MB_OK);
		return(USRE_SOCK_INIT);
	}

	if (LOBYTE(wsaData.wVersion) < 2)
	{
		//AfxMessageBox("Winsock2  ʴ ýԴϴ", MB_OK);
		return(USRE_SOCK_INIT);
	}

	sock = socket(AF_INET, SOCK_STREAM, 0);
	
	if (sock == INVALID_SOCKET)
		return(USRE_SOCK_INIT);

	memset((char *)&SockAddr, 0, sizeof(SockAddr));
	SockAddr.sin_addr.s_addr = inet_addr(lpszAddr);
	SockAddr.sin_port = htons(nPort);
	SockAddr.sin_family = AF_INET;
	
	// Set Socket Option
	int nTimeout = 1;
	if (setsockopt(sock,
				   SOL_SOCKET,
				   SO_REUSEADDR,
				   (char *)&nTimeout,
				   sizeof(nTimeout)) == SOCKET_ERROR)
	{
		nErrCode = WSAGetLastError();
		WSACleanup();
		return(nErrCode);
	}

	// Set Asynchronous Socket I/O
/*
	unsigned long argp = 1;
	if (ioctlsocket(sock, FIONBIO, &argp) == SOCKET_ERROR)
	{
		nErrCode = WSAGetLastError();
		CloseSocket();
		return(nErrCode);
	}
*/
	if ((nErrCode = connect(sock,
					(LPSOCKADDR)&SockAddr,
					sizeof(SockAddr))) == SOCKET_ERROR)
	{
		nErrCode = WSAGetLastError();
		if (nErrCode != WSAEWOULDBLOCK)
		{
			CloseSocket();
			return(nErrCode);
		}
	}

	if (nErrCode != 0)
		CloseSocket();

	return(nErrCode);
}
/////////////////////////////////////////////////////////////////////////////
//Send To TCP
/////////////////////////////////////////////////////////////////////////////
int Send_To(char* lpszSendBuf, UINT nSendLen)
{
	int len, nErrCode;
	int sent_len = 0;

	while (1)
	{
		len = send(sock, lpszSendBuf+sent_len, (int)nSendLen-sent_len, 0);
		if (len == SOCKET_ERROR)
		{
			nErrCode = WSAGetLastError();
			return(nErrCode);
		}
		else if (len == 0)
			return(USRE_SENT_RESULT);

		sent_len += len;

		if (sent_len >= (int)nSendLen)
			break;
	}

	return(0);
}
/////////////////////////////////////////////////////////////////////////////
//Recv From TCP
/////////////////////////////////////////////////////////////////////////////
int Recv_From(char *lpszRecvBuf, int nTimeoutSec, int *nRecvLen)
{
	struct timeval tv;
	fd_set rfds;
	int nErrCode, bytes;

	memset(lpszRecvBuf,	0x00, sizeof(lpszRecvBuf));

	tv.tv_sec = nTimeoutSec;
	tv.tv_usec = 0;
	FD_ZERO(&rfds);
	FD_SET(sock, &rfds);

	int result = select(sock+1, &rfds, NULL, NULL, &tv);
	// select Լ 
	if (result < 0)
	{
		nErrCode = USRE_RECV_FAILED;
		return(nErrCode);
	}
	// ŸӾƿ
	else if (result == 0)
	{
		nErrCode = USRE_RECV_FAILED;
		return(nErrCode);
	}
	
	int nReceivedLen = 0;

	bytes = recv(sock, lpszRecvBuf, 1024, 0);

	if (strlen(lpszRecvBuf) == 0)
		return(USRE_RECV_FAILED);
	
	*nRecvLen = bytes;

	return(0);
}
/*---------------------------------------------------------------------------*/
/* HEX                                                                   */
/*---------------------------------------------------------------------------*/
void    Convert_Hex(unsigned char *Hexbuff, unsigned char *buff, int *rcvlen)
{
    int i;
	unsigned char hex;
	
    for (i = 0; i < *rcvlen ; i++)
    {
          switch(Hexbuff[i])
          {
              case '0'  : hex = 0x00; break;
              case '1'  : hex = 0x01; break;
              case '2'  : hex = 0x02; break;
              case '3'  : hex = 0x03; break;
              case '4'  : hex = 0x04; break;
              case '5'  : hex = 0x05; break;
              case '6'  : hex = 0x06; break;
              case '7'  : hex = 0x07; break;
              case '8'  : hex = 0x08; break;
              case '9'  : hex = 0x09; break;
              case 'A'  :
              case 'a'  : hex = 0x0A; break;
              case 'B'  :
              case 'b'  : hex = 0x0B; break;
              case 'C'  :
              case 'c'  : hex = 0x0C; break;
              case 'D'  :
              case 'd'  : hex = 0x0D; break;
              case 'E'  :
              case 'e'  : hex = 0x0E; break;
              case 'F'  :
              case 'f'  : hex = 0x0F; break;
              default   : hex = 0x00;
          }
		  

    	if(i%2 == 0)
    		buff[i/2] |= hex;
    	else
		{
    		buff[i/2] = buff[i/2] << 4;
			buff[i/2] |= hex;
		}
    }
	*rcvlen = *rcvlen / 2;
}

////////////////////////////////////////////////////////////////////////////////////
//SOCKET ۼ Լ
////////////////////////////////////////////////////////////////////////////////////
extern "C" __declspec(dllexport) int __stdcall 
DoTcpTrans(char *szAddress, long nPort, char *InMsg, char *OutMsg)
{

	char buff[1024], eotbuff[4];
	int nErrCode = 0;
	int i = 0, j = 0, rcvlen = 0, eotlen = 0;
	UINT nResult = 0;

    LotteWorld_Appr_i_t *rLotte_Appr_i = (LotteWorld_Appr_i_t *) InMsg;

	memset(buff, 0x00, sizeof(buff));
	memset(eotbuff, 0x00, sizeof(eotbuff));

	nErrCode = ConnectServer(szAddress, nPort);
	if (nErrCode != 0) 
	{
		CloseSocket();
		return nErrCode;
	}
	
	//Sleep(500);
	nErrCode = Send_To(InMsg, strlen(InMsg));

	if (nErrCode != 0)
	{
		CloseSocket();
		return nErrCode;
	}
	
	//nErrCode = Send_To("EOT", 3);
	//CloseSocket();
	//return nErrCode;

	//	rcvlen = sizeof(buff);
	rcvlen = 0;
	nErrCode = Recv_From((char *)buff, 12, &rcvlen);
	
	if (nErrCode != 0)
	{
		CloseSocket();
		return nErrCode;
	}

	strncpy(OutMsg, buff, strlen(buff));  
	CloseSocket();
	return nErrCode;
}
